# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
# Abe's Enhanced Glossary
#
&CheckBuild(29, "Abe's Glossary", "npa_abe.pl");
push(@Addons_Loaded, 'Abe 2.4');
push(@Addons_PreHeader, 'AbePreHeader');
push(@Addons_PageHandler, 'AbePageHandler');
push(@Addons_MainPage, 'Abe_MainPage');
push(@Addons_NPHTMLFoot, 'Abe_HTMLFoot');
push(@Addons_RemoveNews,'AbeGetReady');
$Addons_List{'Abe 2.4'} = ['npa_abe.pl', 'Run glossary substitution on anything. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a>'];


sub AbePreHeader {
	unshift( @Addons_SaveNews, 'AbeRunSave' );
	unshift( @Addons_RemoveNews2, 'AbeReverse' );
	unshift( @Addons_RemoveNewsSave, 'AbeRunModifySave' );
}

sub AbePageHandler {
	if (query_string() =~ /^abe/i) {
		&AbeMain;
		exit;
	}
}

sub Abe_HTMLFoot {
	if ($up == 3) {
		print qq~ <a href="$scripturl?abe" class="navlink">Abe</a> |~;
	}
}

sub Abe_MainPage {
	if ($up == 3) {
		print qq~
		<b><a href="$scripturl?abe/settings">Abe</a>:</b> Configure Abe's Glossary. (To edit Abe's glossary click <a href="$scripturl?abe">here</a>)<br><br>
		~;
	}
}

sub AbeGetReady {
	&LoadAbe;
	@runfields = split(/\|x\|/, $NPConfig{'abefields'} );
	unless( @runfields ) { return; }
	%runfields = ();
	foreach $afield (@runfields) {
		$runfields{$afield} = 1;
	}
	if( $runfields{'AllFields'} ) {
		local @formfields;
		&SubmitFormFields;
		@abeffields = ( @formfields, 'newstext' );
		foreach $afield (@abeffields) {
			$runfields{$afield} = 1;
		}
	}
	for( $i = 0; $i < @abe; $i++ ) {
		$abe[$i][0] =~ s/\n/<br>/g;
		$abe[$i][0] =~ s/\r/<BR>/g;
		$abe[$i][0] =~ s/``x/` ` x/g;
		$abe[$i][1] =~ s/\n/<br>/g;
		$abe[$i][1] =~ s/\r/<BR>/g;
		$abe[$i][1] =~ s/``x/` ` x/g;
	}
	delete $runfields{'(nil)'};
	@runfields = keys %runfields;
}

sub AbeReverse {
	my ( $i, $afield );
	for( $i = 0; $i < @abe; $i++ ) {
		foreach $afield (@runfields) {
			if( $abe[$i][2] ) {
				${$afield} =~ s/\Q$abe[$i][1]\E/$abe[$i][0]/g;
			}
			else {
				${$afield} =~ s/([^\w\<]|\A)\Q$abe[$i][1]\E([^\w\>]|\Z)/$1$abe[$i][0]$2/g;
			}
		}
	}
}

sub AbeRunModifySave {
	&AbeGetReady;
	my ($nn,$i,$afield);
	for( $nn = 0; $nn < $totnewsnum; $nn++ ) {
		unless ($in{"chk--$nn"} eq 'keep') { next; }
		for( $i = 0; $i < @abe; $i++ ) {
			if( $abe[$i][2] ) {
				foreach $afield (@runfields) {
					$in{"$afield--$nn"} =~ s/\Q$abe[$i][0]\E/$abe[$i][1]/g;
				}
			}
			else {
				foreach $afield (@runfields) {
					$in{"$afield--$nn"} =~ s/([^\w\<]|\A)\Q$abe[$i][0]\E([^\w\>]|\Z)/$1$abe[$i][1]$2/g;
				}
			}
		}
	}
}

sub AbeRunSave {
	&AbeGetReady;
	my ($nn,$i,$afield);
	for( $i = 0; $i < @abe; $i++ ) {
		if( $abe[$i][2] ) {
			foreach $afield (@runfields) {
				${$afield} =~ s/\Q$abe[$i][0]\E/$abe[$i][1]/g;
			}
		}
		else {
			foreach $afield (@runfields) {
				${$afield} =~ s/([^\w\<]|\A)\Q$abe[$i][0]\E([^\w\>]|\Z)/$1$abe[$i][1]$2/g;
			}
		}
	}
}

sub AbeMain {
	if( $in{'abesaveset'} ) {
		# save settings
		&NPHTMLHead("Abe Save Settings");
		print qq~
		<div align="center">~;
		if( $in{'abefile'} ) {
			$NPConfig{'abefile'} = $in{'abefile'};
			$NPConfig{'abefields'} = $in{'abefields'};
			&WriteConfigInfo;
			print q~
			Settings for Abe have been saved.<BR>
			~;
		}
		else {
			print q~
			You must specify a filename for the Abe glossary.<BR>
			<h3><a href="$scripturl?abe/settings">edit Abe settings</a></h3>
			~;
		}
		print qq~
		<h3><a href="$scripturl">back to newspro</a><BR>
		<a href="$scripturl?abe">back to abe</a></h3>
		~;
		&NPHTMLFoot;
		exit;
	}
	elsif( $in{'abeset'} || query_string() eq 'abe/settings' ) {
		# display edit settings
		&NPHTMLHead("Abe Edit Settings");
		print qq~
		<form action="$scripturl?abe" method="POST">
		<table width="100%" cellspacing="5" cellpadding="10" align="center"><tr><td width="30%">
		You may specify the name and relative path of the Abe Glossary file.
		</td><td width="70%">
		<input type="text" name="abefile" size="40" style="width:100%" value="$NPConfig{'abefile'}">
		</td></tr>
		~;
		&SubmitFormFields;
		@abeffields = ( @formfields, 'newstext' );
		my @selectedfields = split(/\|x\|/, $NPConfig{'abefields'} );
		my %selectedfields;
		foreach $i (@selectedfields) {
			$selectedfields{$i} = 'selected';
		}
		print qq~<tr><td valign="middle">Select individual fields to perform replacement on:
		</td><td>
		<select name="abefields" size="10" multiple>
		<option value="AllFields" $selectedfields{'AllFields'}>(All Fields)</option>
		<option value="(nil)" $selectedfields{'nil'}>(nothing selected)</option>
		~;
		foreach $i (@abeffields) {
			print qq~
			<option value="$i" $selectedfields{$i}>$i</option>~;
		}
		print qq~
		</select>
		~;
		print q~
		</tr><tr><td colspan="9"align="center">
		<input type="submit" name="abesaveset" value="Save Abe's Settings">
		</td></tr></table>
		</form>~;
		&NPHTMLFoot;
		exit;
	}
	elsif( exists $in{'abe-f0'} ) {
		#write_to_disk;
		&LoadAbe;
		&NPHTMLHead("Abe Save Glossary");
		my ($i, $ftxt, $ttxt, $wholeword);
		for( $i = 0; exists $in{"abe-f$i"}; $i++ ) {
			$ftxt = $in{"abe-f$i"};
			$ttxt = $in{"abe-t$i"};
			$wholeword = $in{"abe-w$i"};
			$abe[$i] = [ $ftxt, $ttxt, $wholeword ];
			print ( $wholeword ? 'wholeword' : 'inline' ) . qq~ : <BR>$abe[$i][0] / $abe[$i][1]<BR>~ if $AbeDebug;
		}
		print qq~<div align="center">
		<h3><a href="$scripturl">back to newspro</a></h3>
		Abe's Glossary has been saved to $NPConfig{'abefile'}.</div>
		~;
		&SaveAbe;
	}
	else {
		#display_abe_glossary;
		&LoadAbe;
		&NPHTMLHead("Abe Edit Glossary");
		my ($i, $ftxt, $ttxt, $wholeword, $inline);
		print qq~<div align="center">
		<form action="$scripturl?abe" method="POST">
		<h4>Please note that you must edit Abe's settings or no
		glossary replacement will occur.</h4>
		(Abe must be told which fields to run its glossary on)<BR><BR>
		<input type="submit" name="saveabe" value="Save">~;
		for( $i = 0; $i < @abe + 5; $i++ ) {
			if( $i < @abe ) {
				$ftxt = &HTMLescape( $abe[$i][0] );
				$ttxt = &HTMLescape( $abe[$i][1] );
				$wholeword = $abe[$i][2] ? '' : ' checked';
				$inline = $abe[$i][2] ? ' checked' : '';
			}
			else {
				$ftxt = '';
				$ttxt = '';
				$wholeword = ' checked';
				$inline = '';
			}
			print qq~<BR>
			<input type="text" name="abe-f$i" style="width:100%" value="$ftxt"><BR>
			<input type="text" name="abe-t$i" style="width:100%" value="$ttxt"><BR>
			<input type="radio" name="abe-w$i" value=""$wholeword> Whole Words only.
			<input type="radio" name="abe-w$i" value="1"$inline> Partial words &amp; Whole Words.
			<HR size="15" width="75%">
			~;
		}
		print q~
		<input type="submit" name="saveabe" value="Save"><BR>
		<HR size="20">
		<input type="submit" name="abeset" value="Edit Abe Settings"><BR>
		<HR size="20">
		Abe's Glossary<BR>
		by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a><BR>
		<a href="http://www.wwddfd.com" target="ag">perl garden</a>
		</form></div>~;
	}
	&NPHTMLFoot;
}

sub LoadAbe {
	@abe = ();
	unless( $NPConfig{'abefile'} ) {
		$NPConfig{'abefile'} = 'abefile.txt';
		&WriteConfigInfo;
	}
	&AbeReadRayInfo( \@abe, $NPConfig{'abefile'} );
}

sub SaveAbe {
	&AbeWriteRayInfo( \@abe, $NPConfig{'abefile'} );
}

# AbeWriteRayInfo: Saves @$rayref to nsetname
sub AbeWriteRayInfo
{
	my ($rayref, $nsetname) = @_;
	my ($i,$nsetpath);
	if ($abspath)
	{
		$nsetpath = "$abspath/$nsetname";
	}
	$nsetpath = $nsetname unless $nsetpath;
	print qq~<BR><HR><BR>$nsetpath :- $nsetname<BR>~ if $AbeDebug;
	NPopen('ABEF', ">$nsetpath");
	for( $i = 0; $i < @$rayref; $i++ )
	{
		$$rayref[$i][1] ||= '<EMPTY-REPLACEMENT>';
		$$rayref[$i][2] ||= '0';
		if ($$rayref[$i][0] ne '') {
			print ABEF qq~$$rayref[$i][0]``x$$rayref[$i][1]``x$$rayref[$i][2]\n``x``x\n~;
		}
	}
	close(ABEF);
}

# AbeReadRayInfo: Reads hash from file into @$rayref
sub AbeReadRayInfo
{
	my ($rayref, $nsetname) = @_;
	print qq~<BR>aa $nsetname bb<BR>~ if $AbeDebug;
	my (@valarray,$i,$varname,$varvalue,$opt1,$num,$nsetpath);
	if ($abspath)
	{
		$nsetpath = "$abspath/$nsetname";
	}
	$nsetpath = $nsetname unless $nsetpath;
	NPopen('ABEF', $nsetpath);
	{ local $/ = "``x``x" ; @valarray = <ABEF> };
	close(ABEF);
	@$rayref = ();
	$num = 0;
	foreach $i (@valarray)
	{
		$i =~ s/^\s+//;
		$i =~ s/\s+$//;
		$i =~ s/\n//g;
		($varname, $varvalue, $opt1) = split(/``x/, $i);
		print qq~<BR><BR>.... ( $varname .... $varvalue ) ....<BR>~ if $AbeDebug;
		$$rayref[$num] = [ $varname, $varvalue, $opt1 ];
		$num++; 
	}
}
1;
